set verify off
column dummy noprint
column  pct_used format 999.9      heading "% EM USO"
column  name    format a16     	   heading "TABLESPACE NAME"
column  bytes   format 99999999D99 heading "ALOCADO (MB)"
column  used    format 99999999D99 heading "UTILIZADO (MB)"
column  free    format 99999999D99 heading "LIVRE (MB)"
column  filename    format a90     heading "DATAFILE"

break   on report
compute sum of bytes on report
compute sum of free on report
compute sum of used on report

accept own char prompt 'Digite o owner: '

--
-- Verifica informacoes das tablespaces
--

select * from 
(
select b.tablespace_name                                              name,
	b.tablespace_name                                              dummy,
	(sum(nvl(b.bytes,0))/count(distinct a.file_id||'.'||a.block_id ))/1048576      bytes,
	(sum(nvl(b.bytes,0))/count(distinct a.file_id||'.'||a.block_id ) -
	sum(nvl(a.bytes,0))/count(distinct b.file_id ))/1048576           used,
	(sum(nvl(a.bytes,0))/count(distinct b.file_id ))/1048576                       free,
	100 * ( (sum(nvl(b.bytes,0))/count( distinct a.file_id||'.'||a.block_id )) -
	        (sum(nvl(a.bytes, 0))/count( distinct b.file_id ) )) /
	(sum(nvl(b.bytes,0))/count( distinct a.file_id||'.'||a.block_id )) pct_used
from	
	sys.dba_free_space a,
	(select tablespace_name, bytes, file_id 
	from sys.dba_data_files 
	union 
		select tablespace_name, bytes, file_id 
		from sys.dba_temp_files) b
where b.tablespace_name = a.tablespace_name (+)
and b.tablespace_name in (
	select distinct tablespace_name 
	from dba_segments 
	where owner = '&own' 
	and tablespace_name not in ('USERS', 'TEMP')
)
group by b.tablespace_name
order by b.tablespace_name
)
/


undef own
set verify on;

